<?php

/**
* Helper class for Gavick TabMix module
*
* Gavick TabArts
* @package Joomla!
* @Copyright (C) 2008 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @ version $Revision: 2.0 $
**/

// access restriction
defined('_JEXEC') or die('Restricted access');

if (!function_exists('htmlspecialchars_decode')) {
        function htmlspecialchars_decode($str, $options="") {
                $trans = get_html_translation_table(HTML_SPECIALCHARS, $options);

                $decode = ARRAY();
                foreach ($trans AS $char=>$entity) {
                        $decode[$entity] = $char;
                }

                $str = strtr($str, $decode);

                return $str;
        }
}

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class TabMixHelper
{
	var $moduleWidth, 
	$moduleHeight, 
	$tabsGroupID,
	$news_content_header_pos,
	$news_content_image_pos,
	$news_content_text_pos,
	$news_content_readmore_pos,
	$news_readmore_text,
	$news_header_link,
	$news_image_link,
	$news_text_link,
	$news_header_order,
	$news_image_order,
	$news_text_order,
	$news_limit_type,
	$news_limit,
	$clean_xhtml,
	$img_height,
	$img_width,
	$news_datee,
	$news_content_info_pos,
	$news_cats,
	$news_authorr,
	$news_info_order,
	$timezone,
	$date_format, 
	$username,  
	$tabsScroll, 
	$activator, 
	$animation, 
	$animationType, 
	$animationSpeed, 
	$buttons, 
	$styleCSS, 
	$styleFile, 
	$useMoo, 
	$useScript, 
	$tabsTitles,
	$tabsContent,  
	$styleCSSfile, 
	$modGetter, 
	$animationFun, 
	$module_id, 
	$animationInterval, 
	$styleType,
	$clean_code,
	$compress_js,
	$styleSuffix,
	$tabType;
	
	function init(&$params)
	{
		$this->moduleWidth = $params->get('moduleWidth', 0);
		$this->moduleHeight = $params->get('moduleHeight', 0);
		$this->tabsGroupID = $params->get('tabsGroupID', 0);
		$this->styleCSS =  $params->get('styleCSS', 'style1');
		$this->styleFile = $params->get('styleFile', '');
		$this->styleSuffix = $params->get('styleSuffix', '');
		//
		if(strpos($this->moduleHeight,'px') === false) $this->moduleHeight = 0;
		if(strpos($this->moduleWidth,'px') === false && strpos($this->moduleWidth,'%') === false ) $this->moduleWidth = 0;
		//
		$this->styleCSSfile = ($this->styleCSS == "own") ? $this->styleFile : $this->styleCSS;
		$this->styleSuffix = ($this->styleCSS == "own") ? $this->styleSuffix : $this->styleCSS;
	}
	
	function render(&$params)
	{
		$this->activator = $params->get('activator','click');
		$this->animation = $params->get('animation',0);
		$this->animationSpeed = $params->get('animationSpeed', 1000);
		$this->animationInterval = $params->get('animationInterval', 5000);
		$this->useMoo = $params->get('useMoo',1);
		$this->useScript = $params->get('useScript',1);
		$this->animationType = $params->get('animationType', 1);
		$this->buttons = $params->get('buttons', 1);
		$this->styleCSS = $params->get('styleCSS', 'style');
		$this->animationFun = $params->get('animationFun', 'linear');
		$this->module_id = $params->get('module_id', '-mod');
		$this->styleType = $params->get('styleType', 0);
		$this->compress_js = $params->get('compress_js', 1);
		$this->clean_code = $params->get('cleanCode', 1);
		$this->news_content_header_pos = $params->get('news_content_header_pos', 1);
		$this->news_content_image_pos = $params->get('news_content_image_pos', 1);
		$this->news_content_text_pos = $params->get('news_content_text_pos', 1);
		$this->news_content_readmore_pos = $params->get('news_content_readmore_pos', 2);
		$this->news_content_info_pos = $params->get('news_content_info_pos', 1); 
		$this->news_readmore_text = $params->get('news_readmore_text', 'Readmore'); 
		$this->news_header_link = $params->get('news_header_link', 1);
		$this->news_image_link = $params->get('news_image_link', 1);
		$this->news_text_link = $params->get('news_text_link', 0); 
		$this->news_header_order = $params->get('news_header_order', 1);
		$this->news_image_order = $params->get('news_image_order', 2); 
		$this->news_text_order = $params->get('news_text_order', 3); 
		$this->news_limit_type = $params->get('news_limit_type', 0);
		$this->news_limit = $params->get('news_limit', 30); 
		$this->clean_xhtml = $params->get('clean_xhtml', 1); 
		$this->img_height = $params->get('img_height', 0);
		$this->img_width = $params->get('img_width', 0);
		$this->date_format = $params->get('date_format', 'D, d M Y'); 
		$this->news_datee = $params->get('news_date', 1);
		$this->news_cats = $params->get('news_cats', 1);
		$this->news_authorr = $params->get('news_author', 1);
		$this->news_info_order = $params->get('news_info_order', 4);
		$this->timezone = $params->get('news_content_timezone','0');
		$this->username = $params->get('username', 0);
		//
		$this->tabsTitles = array();
		$this->tabsContent = array();
		$this->tabType = array();
		//
		$db	=& JFactory::getDBO();
		$user =& JFactory::getUser();
		$aid = $user->get('aid', 0);
		//
		$query_news = '
		SELECT DISTINCT
			cats.title AS cat, 
			users.'.(($this->username)?'username':'name').' AS author, 
			cats.section AS SID, 
			content.title AS title, 
			content.introtext AS text, 
			content.created AS date, 
			content.images AS images, 
			content.id AS IID,
			tabs.name AS TNAME,
			tabs.type AS type,
			tabs.position AS position,
			tabs.content AS content,
			CASE WHEN CHAR_LENGTH(content.alias) 
				THEN CONCAT_WS(":", `content`.`id`, `content`.`alias`) 
					ELSE `content`.`id` END as ID, 
			CASE WHEN CHAR_LENGTH(cats.alias) 
				THEN CONCAT_WS(":", `cats`.`id`, `cats`.`alias`) 
					ELSE `cats`.`id` END as CID 			
		FROM  
			#__gk2_tabs_manager_tabs AS `tabs` 
			LEFT JOIN
				#__content AS `content` 
				ON `tabs`.`art` = `content`.`id`
			LEFT JOIN 
				#__categories AS `categories` 
				ON `categories`.`id` = `content`.`catid` 
			LEFT JOIN 
				#__sections AS `sections` 
				ON `sections`.`id` = `content`.`sectionid` 
			LEFT JOIN 
				#__menu AS `menu` 
				ON `menu`.`componentid` = `content`.`id` 
			LEFT JOIN 
				#__users AS `users` 
				ON `users`.`id` = `content`.`created_by` 
			LEFT JOIN 
				#__categories AS `cats` 
				ON `content`.`catid` = `cats`.`id` 
		WHERE  
			`tabs`.`group_id` = '.$this->tabsGroupID.' 
			AND
			`tabs`.`published` = 1
			AND 
			`tabs`.`access` <= '.(int) $aid.'
		ORDER BY 
			`tabs`.`order` ASC
		;';
		//
		$db->setQuery($query_news);
		//
		$news_id = array();
		$news_iid = array();
		$news_cid = array();
		$news_title = array();
		$news_text = array();
		$news_images = array();	
		$news_date = array();
		$news_author = array();
		$news_catname = array();
		$news_sid = array();
		$content_pos = array();
		$content_xhtml = array();
		//
		if($news = $db->loadObjectList())
		{
			// generating tables of news data
			foreach($news as $item)
			{
				$news_id[] = $item->ID; // news IDs
				$news_iid[] = $item->IID; // news IDs
				$news_cid[] = $item->CID; // news CIDs
				$news_title[] = $item->title; // news titles
				$news_text[] = $item->text; // news text
				$news_images[] = $item->images; // news images	
				$news_date[] = $item->date; // news dates
				$news_author[] = $item->author; // news author
				$news_catname[] = $item->cat; // news category name
				$news_sid[] = $item->SID; // news category section ID	
				$this->tabsTitles[] = $item->TNAME; // tab title
				$this->tabType[] = $item->type;
				$content_pos[] = $item->position;
				$content_xhtml[] = $item->content;
			}
		}
		//
		for($y = 0;$y < count($this->tabType);$y++)
		{
			if($this->tabType[$y] == 0)
			{
				$this->tabsContent[] = $content_pos[$y];	
			}
			//
			if($this->tabType[$y] == 1)
			{
			/*
				GENERATING NEWS CONTENT
			*/
		
			// GENERATING HEADER
			if($this->news_content_header_pos != 0)
			{
				$news_header = ($this->news_header_link == 1) ? '<h4 class="gk_tabmix_gk1_news_header"><a href="'.JRoute::_(ContentHelperRoute::getArticleRoute($news_id[$y], $news_cid[$y], $news_sid[$y])).'">'.$news_title[$y].'</a></h4>' : '<h4 class="gk_tabmix_gk1_news_header">'.$news_title[$y].'</h4>';
			}
			else
			{
				$news_header = '';
			}
			// GENERATING IMAGE
			$news_image = '';
			$IMG_SOURCE = '';
			$IMG_LINK = JRoute::_(ContentHelperRoute::getArticleRoute($news_id[$y], $news_cid[$y], $news_sid[$y]));
			
			//	
			$imgSPos = strpos($news_text[$y],'src="');
			//
			if($imgSPos)
			{
				$imgEPos = strpos($news_text[$y],'"',$imgSPos+5);
			} 
			//	
			if($imgSPos > 0) 
			{
				$IMG_SOURCE = substr($news_text[$y], ($imgSPos+5), ($imgEPos-($imgSPos+5)));
			}
			//	
			if($IMG_SOURCE != '' && $this->news_content_image_pos != 0)
			{
				//
				if($this->news_image_link == 1){
					$news_image = ($this->news_content_image_pos == 3) ? '<div><a href="'.$IMG_LINK.'"><img class="gk_tabmix_gk1_news_image" src="'.$IMG_SOURCE.'" alt="News image" /></a></div>' : '<a href="'.$IMG_LINK.'"><img class="gk_tabmix_gk1_news_image" src="'.$IMG_SOURCE.'" alt="News image" /></a>';
				}
				else
				{
					$news_image = ($this->news_content_image_pos == 3) ? '<div><img class="gk_tabmix_gk1_news_image" src="'.$IMG_SOURCE.'" alt="News image" /></div>' : $news_image = '<img class="gk_tabmix_gk1_news_image" src="'.$IMG_SOURCE.'" alt="News image" />';
				}
			} 
		// GENERATING READMORE
		$news_readmore = '';
		//
		if($this->news_content_readmore_pos != 0)
		{
			//
			if($this->news_content_readmore_pos != 4)
			{
				$news_readmore = '<a class="readon readon_class" href="'.JRoute::_(ContentHelperRoute::getArticleRoute($news_id[$y], $news_cid[$y], $news_sid[$y])).'">'.$this->news_readmore_text.'</a>';
			}
			else
			{
				$news_readmore = '<a class="gk_tabmix_gk1_news_readmore_inline" href="'.JRoute::_(ContentHelperRoute::getArticleRoute($news_id[$y], $news_cid[$y], $news_sid[$y])).'">'.$this->news_readmore_text.'</a>';
			}
		}
		// GENERATING TEXT
		$news_textt = '';
		//
		if($this->news_content_text_pos != 0)
		{
			//
			$news_textt = str_replace('{mosimage}', '', $news_text[$y]);
			//
			if($this->clean_xhtml == 1) $news_textt = strip_tags($news_textt);
			//
			if($this->news_limit_type == 0)
			{
				$str = $news_textt;
				//
				if(strlen($str) > $this->news_limit)
				{
					$words=explode(' ',preg_replace("/\s+/",' ',preg_replace("/(\r\n|\r|\n)/"," ",$str)));
					//
					if(count($words)>=$this->news_limit)
					{
						$str = '';
						//
						for ($i=0;$i<$this->news_limit;$i++)
						{
							$str.=$words[$i].' ';
						}
						//
						$news_textt = trim($str);
						$news_textt .= "...";
					}
				}
			}
			else
			{
				$str = $news_textt;
				//
				if(strlen($str) > $this->news_limit)
				{
					$str = preg_replace("/\s+/", ' ', preg_replace("/(\r\n|\r|\n)/", " ", $str));
					//	
					if(strlen($str) >= $this->news_limit)
					{						
						$news_textt = substr($str, 0, $this->news_limit);
						$news_textt .= "...";
					}
				}
			}
			//	
			$news_textt = ($this->news_text_link == 1) ? '<a href="'.JRoute::_(ContentHelperRoute::getArticleRoute($news_id[$y], $news_cid[$y], $news_sid[$y])).'">'.$news_textt.'</a>' : $news_textt; 
			//
			$news_textt = ($this->news_content_readmore_pos == 4) ? '<p class="gk_tabmix_gk1_news_text">'.$news_textt.' '.$news_readmore.'</p>' : $news_textt = '<p class="gk_tabmix_gk1_news_text">'.$news_textt.'</p>';
		}
			// GENERATE NEWS INFO
			$news_infoo = '';
			//
			if($this->news_content_info_pos != 0)
			{
				if($this->news_datee == 1 || $this->news_cats == 1 || $this->news_authorr == 1)
				{
					//
					$news_infoo .= '<p class="gk_tabmix_gk1_news_info">';
					//
					if($this->news_cats == 1)
					{
						$news_infoo .= '<a href="'.JRoute::_(ContentHelperRoute::getCategoryRoute($news_cid[$y],$news_sid[$y])).'">'.$news_catname[$y].'</a>';
					}
					//
					if($this->news_authorr == 1)
					{
						if($this->news_cats == 1)
						{
							$news_infoo .= ' | ';
						}
						//
						$news_infoo .= $news_author[$y];
					}			
					//
					if($this->news_datee == 1)
					{
						if($this->news_cats == 1 || $this->news_authorr == 1)
						{
							$news_infoo .= ' | ';
						}
						//
						$GKD = new GK1TabMixDateClass();
						$GKD->init();
						//
						$news_infoo .= $GKD->news_date($news_date[$y], $this->date_format); 
					}
					//
					$news_infoo .= '</p>';
				}	
			}			
			// GENERATE CONTENT FOR TAB
			$news_generated_content = ''; // initialize variable
			//
			for($i = 1;$i < 5;$i++)
			{
				if($this->news_header_order == $i) $news_generated_content .= $news_header;
				if($this->news_image_order == $i) $news_generated_content .= $news_image;
				if($this->news_text_order == $i) $news_generated_content .= $news_textt;
				if($this->news_info_order == $i) $news_generated_content .= $news_infoo;
			}			
			//
			if($this->news_content_readmore_pos != 4) 
			{
				$news_generated_content .= $news_readmore;
			}
			//	
			if($this->show_list == 1)
			{
				// if news on list must be visible
				$li_visible = (($y+1) > $news_rows2 * $this->news_column) ? 'block' : 'none';
				// creating rest news list
				$news_rest_news_list_tab .= '<li class="'.$li_visible.'"><a href="'.JRoute::_(ContentHelperRoute::getArticleRoute($news_id[$y], $news_cid[$y], $news_sid[$y])).'">'.$news_title[$y].'</a></li>';
			}
			// creating table with news content
			$this->tabsContent[] = $news_generated_content;	
			}
			
			if($this->tabType[$y] == 2)
			{
				$this->tabsContent[] = $content_xhtml[$y];	
			}
		}		
		// create instances of basic Joomla! classes
		$document =& JFactory::getDocument();
		$uri = JURI::getInstance();
		// add stylesheets to document header
		$document->addStyleSheet( $uri->root().'modules/mod_tabmix_gk1/style/style.php?moduleHeight='.$this->moduleHeight.'&amp;moduleWidth='.$this->moduleWidth.'&amp;style_suffix='.$this->styleSuffix.'&amp;img_width='.$this->img_width.'&amp;img_height='.$this->img_height.'&amp;news_content_image_pos='.$this->news_content_image_pos.'&amp;news_content_info_pos='.$this->news_content_info_pos.'&amp;news_content_readmore_pos='.$this->news_content_readmore_pos.'&amp;news_content_text_pos='.$this->news_content_text_pos.'&amp;news_content_header_pos='.$this->news_content_header_pos, 'text/css' );
		//
		$document->addStyleSheet( $uri->root().'modules/mod_tabmix_gk1/style/'.$this->styleCSSfile.'.css', 'text/css' );
		
		// init $headData variable
		$headData = false;
		// add scripts with automatic mode to document header
		if($this->useMoo == 2)
		{
			// getting module head section datas
			unset($headData);
			$headData = $document->getHeadData();
			// generate keys of script section
			$headData_keys = array_keys($headData["scripts"]);
			// set variable for false
			$mootools_founded = false;
			// searching phrase mootools in scripts paths
			for($i = 0;$i < count($headData_keys); $i++)
			{
				if(preg_match('/mootools/i', $headData_keys[$i]))
				{
					// if founded set variable to true and break loop
					$mootools_founded = true;
					break;
				}
			}
			// if mootools file doesn't exists in document head section
			if(!$mootools_founded)
			{
				// add new script tag connected with mootools from module
				$headData["scripts"][$uri->root().'modules/mod_tabmix_gk1/js/mootools.js'] = "text/javascript";
				// if added mootools from module then this operation have sense
				$document->setHeadData($headData);
			}
		}
		
		if($this->useScript == 2)
		{
			// getting module head section datas
			unset($headData);
			$headData = $document->getHeadData();
			// generate keys of script section
			$headData_keys = array_keys($headData["scripts"]);
			// set variable for false
			$engine_founded = false;
			// searching phrase mootools in scripts paths
			if(array_search($uri->root().'modules/mod_tabmix_gk1/scripts/engine'.(($this->compress_js == 1) ? '_compress' : '').'.js', $headData_keys) > 0)
			{
				// if founded set variable to true
				$engine_founded = true;
			}
			// if mootools file doesn't exists in document head section
			if(!$engine_founded)
			{
				// add new script tag connected with mootools from module
				$headData["scripts"][$uri->root().'modules/mod_tabmix_gk1/scripts/engine'.(($this->compress_js == 1) ? '_compress' : '').'.js'] = "text/javascript";
				// if added mootools from module then this operation have sense
				$document->setHeadData($headData);
			}
		}
	
		// if clean code is enable use importer.php to include 
		// module settings in head section of document
		if($this->clean_code == 1)
		{
			/* 
				add script tag with module configuration to document head section
			*/	
			
			// get head document section data 
			unset($headData);
			$headData = $document->getHeadData();
			// add new script tag to head document section data array	
			$headData["scripts"][$uri->root().'modules/mod_tabmix_gk1/scripts/importer.php?modid='.$this->module_id.'&amp;activator='.$this->activator.'&amp;animation='.$this->animation.'&amp;animationFun='.$this->animationFun.'&amp;animationType='.$this->animationType.'&amp;animationSpeed='.$this->animationSpeed.'&amp;animationInterval='.$this->animationInterval.'&amp;styleType='.$this->styleType.'&amp;styleSuffix='.$this->styleSuffix] = "text/javascript";
			// if added mootools from module then this operation have sense
			$document->setHeadData($headData);
		} 
						
		// add default.php template to parse if it's needed
		if($this->useMoo != 2 || $this->useScript != 2 || $this->clean_code == 0)
		{
			require(JModuleHelper::getLayoutPath('mod_tabmix_gk1', 'default'));
		}
		
		require(JModuleHelper::getLayoutPath('mod_tabmix_gk1', 'content'));
	}
	
	function moduleRender()
	{	
		for($i = 0;$i < count($this->tabsContent);$i++)
		{
			//
			if($this->tabType[$i] == 0)
			{
				$this->modGetter = &JModuleHelper::getModules($this->tabsContent[$i]);
				require(JModuleHelper::getLayoutPath('mod_tabmix_gk1','module'));
			}
			//
			if($this->tabType[$i] == 1)
			{
				require(JModuleHelper::getLayoutPath('mod_tabmix_gk1','article'));
			}
			//
			if($this->tabType[$i] == 2)
			{
				require(JModuleHelper::getLayoutPath('mod_tabmix_gk1','content_tab'));
			}
		}
	}
}

?>